/*
 =================== DO NOT EDIT THIS FILE ====================
 Generated by Modello 1.0.2 on 2012-03-27 05:30:11,
 any modifications will be overwritten.
 ==============================================================
 */

package org.sonatype.security.model.v2_0_2;

/**
 * A Role is a bucket for privileges, can also contain other roles.
 * 
 * @version $Revision$ $Date$
 */
public class CRole
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * The ID used to reference this role.
     */
    private String id;

    /**
     * A descriptive name for the role.
     */
    private String name;

    /**
     * An explanation of the use of the role.
     */
    private String description;

    /**
     * The number of minutes to wait before the session timeouts
     * because of inactivity.
     */
    private int sessionTimeout = 0;

    /**
     * Field privileges.
     */
    private java.util.List<String> privileges;

    /**
     * Field roles.
     */
    private java.util.List<String> roles;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addPrivilege.
     * 
     * @param string
     */
    public void addPrivilege( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "CRole.addPrivileges(string) parameter must be instanceof " + String.class.getName() );
        }
        getPrivileges().add( string );
    } //-- void addPrivilege( String )

    /**
     * Method addRole.
     * 
     * @param string
     */
    public void addRole( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "CRole.addRoles(string) parameter must be instanceof " + String.class.getName() );
        }
        getRoles().add( string );
    } //-- void addRole( String )

    /**
     * Get an explanation of the use of the role.
     * 
     * @return String
     */
    public String getDescription()
    {
        return this.description;
    } //-- String getDescription()

    /**
     * Get the ID used to reference this role.
     * 
     * @return String
     */
    public String getId()
    {
        return this.id;
    } //-- String getId()

    /**
     * Get a descriptive name for the role.
     * 
     * @return String
     */
    public String getName()
    {
        return this.name;
    } //-- String getName()

    /**
     * Method getPrivileges.
     * 
     * @return List
     */
    public java.util.List<String> getPrivileges()
    {
        if ( this.privileges == null )
        {
            this.privileges = new java.util.ArrayList<String>();
        }

        return this.privileges;
    } //-- java.util.List<String> getPrivileges()

    /**
     * Method getRoles.
     * 
     * @return List
     */
    public java.util.List<String> getRoles()
    {
        if ( this.roles == null )
        {
            this.roles = new java.util.ArrayList<String>();
        }

        return this.roles;
    } //-- java.util.List<String> getRoles()

    /**
     * Get the number of minutes to wait before the session
     * timeouts because of inactivity.
     * 
     * @return int
     */
    public int getSessionTimeout()
    {
        return this.sessionTimeout;
    } //-- int getSessionTimeout()

    /**
     * Method removePrivilege.
     * 
     * @param string
     */
    public void removePrivilege( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "CRole.removePrivileges(string) parameter must be instanceof " + String.class.getName() );
        }
        getPrivileges().remove( string );
    } //-- void removePrivilege( String )

    /**
     * Method removeRole.
     * 
     * @param string
     */
    public void removeRole( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "CRole.removeRoles(string) parameter must be instanceof " + String.class.getName() );
        }
        getRoles().remove( string );
    } //-- void removeRole( String )

    /**
     * Set an explanation of the use of the role.
     * 
     * @param description
     */
    public void setDescription( String description )
    {
        this.description = description;
    } //-- void setDescription( String )

    /**
     * Set the ID used to reference this role.
     * 
     * @param id
     */
    public void setId( String id )
    {
        this.id = id;
    } //-- void setId( String )

    /**
     * Set a descriptive name for the role.
     * 
     * @param name
     */
    public void setName( String name )
    {
        this.name = name;
    } //-- void setName( String )

    /**
     * Set list of privilege ids that will define this role.
     * 
     * @param privileges
     */
    public void setPrivileges( java.util.List<String> privileges )
    {
        this.privileges = privileges;
    } //-- void setPrivileges( java.util.List )

    /**
     * Set list of role ids, whose contents, will also define this
     * role.
     * 
     * @param roles
     */
    public void setRoles( java.util.List<String> roles )
    {
        this.roles = roles;
    } //-- void setRoles( java.util.List )

    /**
     * Set the number of minutes to wait before the session
     * timeouts because of inactivity.
     * 
     * @param sessionTimeout
     */
    public void setSessionTimeout( int sessionTimeout )
    {
        this.sessionTimeout = sessionTimeout;
    } //-- void setSessionTimeout( int )


}
