/*
 * $Id$
 */

package org.sonatype.security.model.v2_0_3.upgrade;

/**
 * Converts between version 2.0.2 and version 2.0.3 of the model.
 * 
 * @version $Revision$ $Date$
 */
public class BasicVersionUpgrade
    implements org.sonatype.security.model.v2_0_3.upgrade.VersionUpgrade
{

      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method upgradeCPrivilege.
     * 
     * @param cPrivilege
     * @return CPrivilege
     */
    public org.sonatype.security.model.v2_0_3.CPrivilege upgradeCPrivilege( org.sonatype.security.model.v2_0_2.CPrivilege cPrivilege )
    {
        return upgradeCPrivilege( cPrivilege, new org.sonatype.security.model.v2_0_3.CPrivilege() );
    } //-- org.sonatype.security.model.v2_0_3.CPrivilege upgradeCPrivilege( org.sonatype.security.model.v2_0_2.CPrivilege )

    /**
     * Method upgradeCPrivilege.
     * 
     * @param cPrivilege
     * @param value
     * @return CPrivilege
     */
    public org.sonatype.security.model.v2_0_3.CPrivilege upgradeCPrivilege( org.sonatype.security.model.v2_0_2.CPrivilege cPrivilege, org.sonatype.security.model.v2_0_3.CPrivilege value )
    {
        if ( cPrivilege == null )
        {
            return null;
        }
        // Convert field id
        value.setId( cPrivilege.getId() );
        // Convert field name
        value.setName( cPrivilege.getName() );
        // Convert field description
        value.setDescription( cPrivilege.getDescription() );
        // Convert field type
        value.setType( cPrivilege.getType() );
        {
            java.util.List list = new java.util.ArrayList/*<CProperty>*/();
            for ( java.util.Iterator i = cPrivilege.getProperties().iterator(); i.hasNext(); )
            {
                org.sonatype.security.model.v2_0_2.CProperty v = (org.sonatype.security.model.v2_0_2.CProperty) i.next();
                list.add( upgradeCProperty( v ) );
            }
            value.setProperties( list );
        }

        return value;
    } //-- org.sonatype.security.model.v2_0_3.CPrivilege upgradeCPrivilege( org.sonatype.security.model.v2_0_2.CPrivilege, org.sonatype.security.model.v2_0_3.CPrivilege )

    /**
     * Method upgradeCProperty.
     * 
     * @param cProperty
     * @return CProperty
     */
    public org.sonatype.security.model.v2_0_3.CProperty upgradeCProperty( org.sonatype.security.model.v2_0_2.CProperty cProperty )
    {
        return upgradeCProperty( cProperty, new org.sonatype.security.model.v2_0_3.CProperty() );
    } //-- org.sonatype.security.model.v2_0_3.CProperty upgradeCProperty( org.sonatype.security.model.v2_0_2.CProperty )

    /**
     * Method upgradeCProperty.
     * 
     * @param cProperty
     * @param value
     * @return CProperty
     */
    public org.sonatype.security.model.v2_0_3.CProperty upgradeCProperty( org.sonatype.security.model.v2_0_2.CProperty cProperty, org.sonatype.security.model.v2_0_3.CProperty value )
    {
        if ( cProperty == null )
        {
            return null;
        }
        // Convert field key
        value.setKey( cProperty.getKey() );
        // Convert field value
        value.setValue( cProperty.getValue() );

        return value;
    } //-- org.sonatype.security.model.v2_0_3.CProperty upgradeCProperty( org.sonatype.security.model.v2_0_2.CProperty, org.sonatype.security.model.v2_0_3.CProperty )

    /**
     * Method upgradeCRole.
     * 
     * @param cRole
     * @return CRole
     */
    public org.sonatype.security.model.v2_0_3.CRole upgradeCRole( org.sonatype.security.model.v2_0_2.CRole cRole )
    {
        return upgradeCRole( cRole, new org.sonatype.security.model.v2_0_3.CRole() );
    } //-- org.sonatype.security.model.v2_0_3.CRole upgradeCRole( org.sonatype.security.model.v2_0_2.CRole )

    /**
     * Method upgradeCRole.
     * 
     * @param cRole
     * @param value
     * @return CRole
     */
    public org.sonatype.security.model.v2_0_3.CRole upgradeCRole( org.sonatype.security.model.v2_0_2.CRole cRole, org.sonatype.security.model.v2_0_3.CRole value )
    {
        if ( cRole == null )
        {
            return null;
        }
        // Convert field id
        value.setId( cRole.getId() );
        // Convert field name
        value.setName( cRole.getName() );
        // Convert field description
        value.setDescription( cRole.getDescription() );
        // Convert field sessionTimeout
        value.setSessionTimeout( cRole.getSessionTimeout() );
        {
            java.util.List list = new java.util.ArrayList/*<String>*/();
            for ( java.util.Iterator i = cRole.getPrivileges().iterator(); i.hasNext(); )
            {
                String v = (String) i.next();
                list.add( v );
            }
            value.setPrivileges( list );
        }
        {
            java.util.List list = new java.util.ArrayList/*<String>*/();
            for ( java.util.Iterator i = cRole.getRoles().iterator(); i.hasNext(); )
            {
                String v = (String) i.next();
                list.add( v );
            }
            value.setRoles( list );
        }

        return value;
    } //-- org.sonatype.security.model.v2_0_3.CRole upgradeCRole( org.sonatype.security.model.v2_0_2.CRole, org.sonatype.security.model.v2_0_3.CRole )

    /**
     * Method upgradeCUser.
     * 
     * @param cUser
     * @return CUser
     */
    public org.sonatype.security.model.v2_0_3.CUser upgradeCUser( org.sonatype.security.model.v2_0_2.CUser cUser )
    {
        return upgradeCUser( cUser, new org.sonatype.security.model.v2_0_3.CUser() );
    } //-- org.sonatype.security.model.v2_0_3.CUser upgradeCUser( org.sonatype.security.model.v2_0_2.CUser )

    /**
     * Method upgradeCUser.
     * 
     * @param cUser
     * @param value
     * @return CUser
     */
    public org.sonatype.security.model.v2_0_3.CUser upgradeCUser( org.sonatype.security.model.v2_0_2.CUser cUser, org.sonatype.security.model.v2_0_3.CUser value )
    {
        if ( cUser == null )
        {
            return null;
        }
        // Convert field id
        value.setId( cUser.getId() );
        // Convert field name
        value.setName( cUser.getName() );
        // Convert field password
        value.setPassword( cUser.getPassword() );
        // Convert field status
        value.setStatus( cUser.getStatus() );
        // Convert field email
        value.setEmail( cUser.getEmail() );

        return value;
    } //-- org.sonatype.security.model.v2_0_3.CUser upgradeCUser( org.sonatype.security.model.v2_0_2.CUser, org.sonatype.security.model.v2_0_3.CUser )

    /**
     * Method upgradeCUserRoleMapping.
     * 
     * @param cUserRoleMapping
     * @return CUserRoleMapping
     */
    public org.sonatype.security.model.v2_0_3.CUserRoleMapping upgradeCUserRoleMapping( org.sonatype.security.model.v2_0_2.CUserRoleMapping cUserRoleMapping )
    {
        return upgradeCUserRoleMapping( cUserRoleMapping, new org.sonatype.security.model.v2_0_3.CUserRoleMapping() );
    } //-- org.sonatype.security.model.v2_0_3.CUserRoleMapping upgradeCUserRoleMapping( org.sonatype.security.model.v2_0_2.CUserRoleMapping )

    /**
     * Method upgradeCUserRoleMapping.
     * 
     * @param cUserRoleMapping
     * @param value
     * @return CUserRoleMapping
     */
    public org.sonatype.security.model.v2_0_3.CUserRoleMapping upgradeCUserRoleMapping( org.sonatype.security.model.v2_0_2.CUserRoleMapping cUserRoleMapping, org.sonatype.security.model.v2_0_3.CUserRoleMapping value )
    {
        if ( cUserRoleMapping == null )
        {
            return null;
        }
        // Convert field userId
        value.setUserId( cUserRoleMapping.getUserId() );
        // Convert field source
        value.setSource( cUserRoleMapping.getSource() );
        {
            java.util.List list = new java.util.ArrayList/*<String>*/();
            for ( java.util.Iterator i = cUserRoleMapping.getRoles().iterator(); i.hasNext(); )
            {
                String v = (String) i.next();
                list.add( v );
            }
            value.setRoles( list );
        }

        return value;
    } //-- org.sonatype.security.model.v2_0_3.CUserRoleMapping upgradeCUserRoleMapping( org.sonatype.security.model.v2_0_2.CUserRoleMapping, org.sonatype.security.model.v2_0_3.CUserRoleMapping )

    /**
     * Method upgradeConfiguration.
     * 
     * @param configuration
     * @return Configuration
     */
    public org.sonatype.security.model.v2_0_3.Configuration upgradeConfiguration( org.sonatype.security.model.v2_0_2.Configuration configuration )
    {
        return upgradeConfiguration( configuration, new org.sonatype.security.model.v2_0_3.Configuration() );
    } //-- org.sonatype.security.model.v2_0_3.Configuration upgradeConfiguration( org.sonatype.security.model.v2_0_2.Configuration )

    /**
     * Method upgradeConfiguration.
     * 
     * @param configuration
     * @param value
     * @return Configuration
     */
    public org.sonatype.security.model.v2_0_3.Configuration upgradeConfiguration( org.sonatype.security.model.v2_0_2.Configuration configuration, org.sonatype.security.model.v2_0_3.Configuration value )
    {
        if ( configuration == null )
        {
            return null;
        }
        // Convert field version
        value.setVersion( configuration.getVersion() );
        {
            java.util.List list = new java.util.ArrayList/*<CUser>*/();
            for ( java.util.Iterator i = configuration.getUsers().iterator(); i.hasNext(); )
            {
                org.sonatype.security.model.v2_0_2.CUser v = (org.sonatype.security.model.v2_0_2.CUser) i.next();
                list.add( upgradeCUser( v ) );
            }
            value.setUsers( list );
        }
        {
            java.util.List list = new java.util.ArrayList/*<CRole>*/();
            for ( java.util.Iterator i = configuration.getRoles().iterator(); i.hasNext(); )
            {
                org.sonatype.security.model.v2_0_2.CRole v = (org.sonatype.security.model.v2_0_2.CRole) i.next();
                list.add( upgradeCRole( v ) );
            }
            value.setRoles( list );
        }
        {
            java.util.List list = new java.util.ArrayList/*<CPrivilege>*/();
            for ( java.util.Iterator i = configuration.getPrivileges().iterator(); i.hasNext(); )
            {
                org.sonatype.security.model.v2_0_2.CPrivilege v = (org.sonatype.security.model.v2_0_2.CPrivilege) i.next();
                list.add( upgradeCPrivilege( v ) );
            }
            value.setPrivileges( list );
        }
        {
            java.util.List list = new java.util.ArrayList/*<CUserRoleMapping>*/();
            for ( java.util.Iterator i = configuration.getUserRoleMappings().iterator(); i.hasNext(); )
            {
                org.sonatype.security.model.v2_0_2.CUserRoleMapping v = (org.sonatype.security.model.v2_0_2.CUserRoleMapping) i.next();
                list.add( upgradeCUserRoleMapping( v ) );
            }
            value.setUserRoleMappings( list );
        }

        return value;
    } //-- org.sonatype.security.model.v2_0_3.Configuration upgradeConfiguration( org.sonatype.security.model.v2_0_2.Configuration, org.sonatype.security.model.v2_0_3.Configuration )


}
